Ручное поднятие (бросание)исключения в Питоне

python exception


Как я могу вызвать исключение в Python, чтобы позже его можно было перехватить через блок except ?




Answer 1 Aaron Hall


Как вручную бросить/поднять исключение на Питоне?

Используйте наиболее специфический конструктор исключений, который семантически соответствует вашей проблеме .

Будьте конкретны в вашем сообщении,например:

raise ValueError('A very specific bad thing happened.')

Не поднимайте общие исключения

Избегайте поднятия общего Exception . Чтобы поймать его, вам нужно поймать все другие более конкретные исключения, которые подкласс его.

Проблема 1:Скрытие ошибок

raise Exception('I know Python!') # Don't! If you catch, likely to hide bugs.

Например:

def demo_bad_catch():
    try:
        raise ValueError('Represents a hidden bug, do not catch this')
        raise Exception('This is the exception you expect to handle')
    except Exception as error:
        print('Caught this error: ' + repr(error))

>>> demo_bad_catch()
Caught this error: ValueError('Represents a hidden bug, do not catch this',)

Проблема 2:Не поймаешь

И более конкретные уловы не станут исключением:

def demo_no_catch():
    try:
        raise Exception('general exceptions not caught by specific handling')
    except ValueError as e:
        print('we will not catch exception: Exception')


>>> demo_no_catch()
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "<stdin>", line 3, in demo_no_catch
Exception: general exceptions not caught by specific handling

Лучшие практики: raise заявление

Вместо этого используйте наиболее конкретный конструктор исключений, который семантически соответствует вашей проблеме .

raise ValueError('A very specific bad thing happened')

что также удобно позволяет передавать конструктору произвольное количество аргументов:

raise ValueError('A very specific bad thing happened', 'foo', 'bar', 'baz') 

Эти аргументы доступны через атрибут args объекта Exception . Например:

try:
    some_code_that_may_raise_our_value_error()
except ValueError as err:
    print(err.args)

prints

('message', 'foo', 'bar', 'baz')    

В Python 2.5 в BaseException был добавлен фактический атрибут message чтобы поощрять пользователей создавать подклассы исключений и прекратить использование args , но введение message и первоначальный отказ от аргументов были отменены .

Лучшие практики: except пункта

Внутри пункта исключение,вы можете захотеть,например,записать в журнал,что произошла ошибка определенного типа,а затем повторно подняться.Лучший способ сделать это при сохранении трассировки стека-использовать утверждение "голый поднятие".Например:

logger = logging.getLogger(__name__)

try:
    do_something_in_app_that_breaks_easily()
except AppError as error:
    logger.error(error)
    raise                 # just this!
    # raise AppError      # Don't do this, you'll lose the stack trace!

Не модифицируйте свои ошибки...но если вы настаиваете.

Вы можете сохранить трассировку стека (и значение ошибки) с помощью sys.exc_info() , но это более подвержено ошибкам и имеет проблемы совместимости между Python 2 и 3 , предпочитая использовать голый raise для повторного рейза.

Для объяснения - sys.exc_info() возвращает тип, значение и обратную трассировку .

type, value, traceback = sys.exc_info()

Это синтаксис на Python 2-обратите внимание,что он не совместим с Python 3:

    raise AppError, error, sys.exc_info()[2] # avoid this.
    # Equivalently, as error *is* the second object:
    raise sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2]

Если вы хотите, вы можете изменить то, что происходит с вашим новым рейзом - например, установить новые args для экземпляра:

def error():
    raise ValueError('oops!')

def catch_error_modify_message():
    try:
        error()
    except ValueError:
        error_type, error_instance, traceback = sys.exc_info()
        error_instance.args = (error_instance.args[0] + ' <modification>',)
        raise error_type, error_instance, traceback

И мы сохранили всю трассировку при модификации аргументов. Обратите внимание, что это не лучшая практика и это недопустимый синтаксис в Python 3 (что делает совместимость намного сложнее).

>>> catch_error_modify_message()
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "<stdin>", line 3, in catch_error_modify_message
  File "<stdin>", line 2, in error
ValueError: oops! <modification>

В Python 3 :

    raise error.with_traceback(sys.exc_info()[2])

Опять же: избегайте ручного манипулирования трассировками. Это менее эффективно и более подвержено ошибкам. И если вы используете многопоточность и sys.exc_info , вы можете даже получить неправильный результат трассировки (особенно если вы используете обработку исключений для потока управления - чего я бы лично избегал).

Питон 3,Исключительная цепочка

На Python 3,вы можете цеплять Исключения,которые сохраняют следы:

    raise RuntimeError('specific message') from error

Будь в курсе:

  • это действительно позволит изменить тип ошибки воскресают и
  • это не совместимо с Python 2.

Исключительные методы:

Они могут легко спрятаться и даже попасть в рабочий код. Вы хотите вызвать исключение, и выполнение их вызовет исключение, но не то, которое намеревалось!

Допустимо в Python 2, но не в Python 3 :

raise ValueError, 'message' # Don't do this, it's deprecated!

Действует только в гораздо более старых версиях Python (2.4 и ниже), вы все равно можете увидеть людей, поднимающих строки:

raise 'message' # really really wrong. don't do this.

Во всех современных версиях это фактически вызовет TypeError , потому что вы не BaseException тип BaseException . Если вы не проверяете правильное исключение и у вас нет рецензента, который знает об этой проблеме, он может быть запущен в производство.

Пример использования

Я повышаю Исключения,чтобы предупредить потребителей о моем API,если они используют его неправильно:

def api_func(foo):
    '''foo should be either 'baz' or 'bar'. returns something very useful.'''
    if foo not in _ALLOWED_ARGS:
        raise ValueError('{foo} wrong, use "baz" or "bar"'.format(foo=repr(foo)))

Создавайте свои собственные типы ошибок,когда apropos

«Я хочу нарочно сделать ошибку, чтобы она пошла в исключение»

Вы можете создать свои собственные типы ошибок,если хотите указать,что с вашим приложением что-то не так,просто выделите соответствующую точку в иерархии исключений:

class MyAppLookupError(LookupError):
    '''raise this when there's a lookup error for my app'''

и использование:

if important_key not in resource_dict and not ok_to_be_missing:
    raise MyAppLookupError('resource is missing, and that is not ok.')



Answer 2 Gabriel Hurley


НЕ ДЕЛАЙТЕ ЭТОГО . Вызывать голое Exception абсолютно не правильно; см . отличный ответ Аарона Холла .

Не может быть больше питонического,чем это:

raise Exception("I know python!")

Если вам нужна дополнительная информация, смотрите документацию по поднятиям для python.




Answer 3 N Randhawa


На Python3 есть 4 различных синтаксиса для исключений рангов:

1. raise exception 
2. raise exception (args) 
3. raise
4. raise exception (args) from original_exception

1. поднять исключение против 2. поднять исключение (аргументы)

Если вы используете raise exception (args) чтобы возбудить исключение, то при печати объекта исключения будут напечатаны args - как показано в примере ниже.

  #raise exception (args)
    try:
        raise ValueError("I have raised an Exception")
    except ValueError as exp:
        print ("Error", exp)     # Output -> Error I have raised an Exception 



  #raise execption 
    try:
        raise ValueError
    except ValueError as exp:
        print ("Error", exp)     # Output -> Error 

3.raise

raise оператор без каких-либо аргументов повторно вызывает последнее исключение. Это полезно, если вам нужно выполнить некоторые действия после перехвата исключения, а затем повторно вызвать его. Но если раньше не было никаких исключений, оператор raise вызывает исключение TypeError .

def somefunction():
    print("some cleaning")

a=10
b=0 
result=None

try:
    result=a/b
    print(result)

except Exception:            #Output ->
    somefunction()           #some cleaning
    raise                    #Traceback (most recent call last):
                             #File "python", line 8, in <module>
                             #ZeroDivisionError: division by zero

4. поднять исключение (аргументы) из оригинального исключения

Данное утверждение используется для создания цепочки исключений,в которой исключение,поднятое в ответ на другое исключение,может содержать детали исходного исключения-как показано в примере ниже.

class MyCustomException(Exception):
pass

a=10
b=0 
reuslt=None
try:
    try:
        result=a/b

    except ZeroDivisionError as exp:
        print("ZeroDivisionError -- ",exp)
        raise MyCustomException("Zero Division ") from exp

except MyCustomException as exp:
        print("MyException",exp)
        print(exp.__cause__)

Output:

ZeroDivisionError --  division by zero
MyException Zero Division 
division by zero



Answer 4 Evgeni Sergeev


Для общего случая, когда вам нужно выдать исключение в ответ на некоторые непредвиденные условия, и который вы никогда не намереваетесь отловить, а просто быстро потерпеть неудачу, чтобы дать вам возможность отладки оттуда, если это когда-либо произойдет, - наиболее логичным кажется AssertionError :

if 0 < distance <= RADIUS:
    #Do something.
elif RADIUS < distance:
    #Do something.
else:
    raise AssertionError("Unexpected value of 'distance'!", distance)



Answer 5 Anant Prakash


Сначала прочтите существующие ответы, это всего лишь дополнение.

Обратите внимание,что вы можете выдвигать исключения с аргументами или без аргументов.

Example:

raise SystemExit

выходит из программы,но вы,возможно,захотите узнать,что случилось.Так что вы можете использовать это.

raise SystemExit("program exited")

в stderr перед закрытием программы будет выведена надпись "program exited".